---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: query-api
  name: query-api
  annotations:
    secret.reloader.stakater.com/reload: "kustomize_placeholder"
spec:
  replicas: 3
  selector:
    matchLabels:
      app: query-api
  strategy:
    rollingUpdate:
      maxSurge: 33%
      maxUnavailable: 33%
    type: RollingUpdate
  template:
    metadata:
      labels:
        app: query-api
      name: query-api
    spec:
      containers:
        - image: query-api-image-placeholder
          args:
            - -metrics-bind-address=:8081
            - "-redis-password=$(REDIS_PASSWORD)"
            - "-redis-address=$(REDIS_ADDRESS)"
            - -rate-limit-config-path=/etc/rate-limits/limits.yaml
          env:
            - name: OIDC_PRIVATE_KEY_PEM
              valueFrom:
                secretKeyRef:
                  key: oidc_private_key_pem
                  name: kustomize_placeholder
                  optional: true
            - name: TLS_SKIP_INSECURE_VERIFY
              value: kustomize_placeholder
            - name: REDIS_ADDRESS
              value: kustomize_placeholder
            - name: REDIS_PASSWORD
              valueFrom:
                secretKeyRef:
                  key: password
                  name: redis
          imagePullPolicy: IfNotPresent
          name: query-api
          ports:
            - containerPort: 8080
              name: http
            - containerPort: 8081
              name: metrics
          readinessProbe:
            initialDelaySeconds: 5
            periodSeconds: 5
            httpGet:
              port: http
              path: /readyz
          resources:
            limits:
              cpu: "2"
              memory: 3Gi
            requests:
              cpu: 100m
              memory: 256Mi
          volumeMounts:
            - mountPath: /etc/rate-limits/
              name: rate-limits-configuration
          securityContext:
            allowPrivilegeEscalation: false
      securityContext:
        runAsUser: 65532
      serviceAccountName: query-api
      terminationGracePeriodSeconds: 30
      volumes:
        - configMap:
            defaultMode: 420
            items:
              - key: limits.yaml
                path: limits.yaml
            name: ratelimits-config
            optional: true
          name: rate-limits-configuration
